/**
 * 单例基类
 *
 * @export
 * @class Singleton
 */
export class Singleton{
    /**
     * 唯一实例
     * 
     * @private
     * @static
     * @memberof Singleton
     */
     private static readonly instance = new Singleton();

     /**
      * 获取唯一实例
      *
      * @static
      * @return {*}  {Singleton}
      * @memberof Singleton
      */
     public static getInstance(): Singleton {
         return Singleton.instance;
     }

}